package com.boman.web.core.mapper;

import com.alibaba.fastjson.JSONObject;
import com.boman.domain.Czrk;
import com.boman.domain.SysDept;
import com.boman.domain.VaccineInfoOperation;
import com.boman.web.core.domain.ConfirmInfoUser;
import org.apache.ibatis.annotations.Param;
import org.checkerframework.checker.units.qual.C;

import java.util.List;


/**
 * 常住人口Mapper接口
 *
 * @author ruoyi
 * @date 2022-01-14
 */
public interface CzrkMapper {
    /**
     * 查询常住人口
     *
     * @param id 常住人口主键
     * @return 常住人口
     */
    Czrk selectCzrkById(Long id);
    List<Czrk> selectCzrkByIds(@Param("ids") List<Long> ids);
    int countIdCard(String idCard);

    /**
     * 查询常住人口列表
     *
     * @param czrk 常住人口
     * @return 常住人口集合
     */
    List<Czrk> selectCzrkList(Czrk czrk);

    /**
     * 新增常住人口
     *
     * @param czrk 常住人口
     * @return 结果
     */
    int insertCzrk(Czrk czrk);

    /**
     * 修改常住人口
     *
     * @param czrk 常住人口
     * @return 结果
     */
    int updateCzrk(Czrk czrk);

    /**
     * 删除常住人口
     *
     * @param id 常住人口主键
     * @return 结果
     */
    int deleteCzrkById(Long id);

    int reduction(String id);


//    int deleteCzrk(Long[] ids);
    int deleteCzrk(Czrk czrk);

    List<Czrk> listByRlry(Czrk czrk);
    List<Czrk> listByRlryRel(Czrk czrk);

    List<Czrk> listByXz(Czrk czrk);
    List<Czrk> listByJs(Czrk czrk);
//    int countByJs(Czrk czrk);
//    int countByXz(Czrk czrk);
    int countCzrk(@Param("type") int type, @Param("areaId") Long areaId);


    List<Czrk> listByCode(String code);

    List<Czrk> listByCodeSynchronization(String code);

    int stsByYrl(@Param("type") int type, @Param("areaId") Long areaId, @Param("userName") String userName, @Param("houseType") String houseType,@Param("isConfirm")String isConfirm);
    int stsByWrl(@Param("type") int type, @Param("areaId") Long areaId, @Param("userName") String userName, @Param("houseType") String houseType,@Param("isConfirm")String isConfirm);

    List<Czrk> listIsRl(@Param("type") int type, @Param("areaId") Long areaId, @Param("userName") String userName);

//    int stsByWrl(@Param("deptIdList") List<Long> deptIdList, @Param("userName") String userName);


    /**
     *根据身份证号查询用户信息
     * @param czrk
     * @return
     */
   Czrk findHjInfo(Czrk czrk);
    List<Czrk> stsByAppletCz(@Param("type") int type, @Param("areaId") Long areaId, @Param("userName") String userName, @Param("houseType") String houseType,@Param("isConfirm") String isConfirm);

    List<Czrk> listByCzXz(@Param("startTime") String startTime, @Param("endTime") String endTime, @Param("type") int type, @Param("areaId") Long areaId);
    List<Czrk> listByCzJs(@Param("startTime") String startTime, @Param("endTime") String endTime, @Param("type") int type, @Param("areaId") Long areaId);

    int countByCzXz(@Param("startTime") String startTime, @Param("endTime") String endTime, @Param("type") int type, @Param("areaId") Long areaId);
    int countByCzJs(@Param("startTime") String startTime, @Param("endTime") String endTime, @Param("type") int type, @Param("areaId") Long areaId);

    int countByHjXz(@Param("startTime") String startTime, @Param("endTime") String endTime, @Param("type") int type, @Param("areaId") Long areaId);
    List<Czrk>  listByHjXz(@Param("startTime") String startTime, @Param("endTime") String endTime, @Param("type") int type, @Param("areaId") Long areaId);

    int countByHjJs(@Param("startTime") String startTime, @Param("endTime") String endTime, @Param("type") int type, @Param("areaId") Long areaId);
    List<Czrk> listByHjJs(@Param("startTime") String startTime, @Param("endTime") String endTime, @Param("type") int type, @Param("areaId") Long areaId);

    int countHj(@Param("startTime") String startTime, @Param("endTime") String endTime, @Param("type") int type, @Param("areaId") Long areaId);

    int countAll();
    //分页查询
  List<Czrk>  selectCzrkListByPage(@Param("startNum") int startNum, @Param("endNum") int endNum);


  //查询部门表数据
  SysDept selectDeptNameById(@Param("id")Long id);

    int countHj1(@Param("deptIdList") List<Long> deptIdList);
    int countCz1(@Param("deptIdList") List<Long> deptIdList);

    int countByHjXz1(@Param("startTime") String startTime, @Param("endTime") String endTime, @Param("deptIdList") List<Long> deptIdList);
    int countByHjJs1(@Param("startTime") String startTime, @Param("endTime") String endTime, @Param("deptIdList") List<Long> deptIdList);
    List<Czrk> listByHjXz1(@Param("startTime") String startTime, @Param("endTime") String endTime, @Param("deptIdList") List<Long> deptIdList);
    List<Czrk> listByHjJs1(@Param("startTime") String startTime, @Param("endTime") String endTime, @Param("deptIdList") List<Long> deptIdList);

    int countByCzXz1(@Param("startTime") String startTime, @Param("endTime") String endTime, @Param("deptIdList") List<Long> deptIdList);
    List<Czrk> listByCzXz1(@Param("startTime") String startTime, @Param("endTime") String endTime, @Param("deptIdList") List<Long> deptIdList);
    int countByCzJs1(@Param("startTime") String startTime, @Param("endTime") String endTime, @Param("deptIdList") List<Long> deptIdList);
    List<Czrk> listByCzJs1(@Param("startTime") String startTime, @Param("endTime") String endTime, @Param("deptIdList") List<Long> deptIdList);

    Czrk getHzByCode(String code);

    JSONObject getColumnNamesByIdCard(@Param("columnNames") String columnNames, @Param("idCard") String idCard);

    /**
     * 一键确认家庭成员
     * @param ids
     * @return
     */
    int confirmInfoByIds(@Param("ids") Long[] ids, @Param("userName") String userName);

    int insertConfirmInfoUser(ConfirmInfoUser confirmInfoUser);

    int updateHouseholdRegister(@Param("czrk") Czrk czrk);
}
